#include "stdafx.h"
#include "Project.hpp"

#include <string>
#include <fstream>

using std::ifstream;
using std::string;

const static int kBUFFER_SIZE = 1024;

void Project::CalculateSourceAndObjectFiles()
{
	ifstream fVcProj( m_Location.c_str() );
	char	szBuffer[kBUFFER_SIZE];
	string	sBuffer;

	if (!fVcProj.is_open())
	{
		printf("Could not open specified project file (.vcproj)\n");
		return;
	}

	while ( !fVcProj.eof() )
	{
		fVcProj.getline(szBuffer, kBUFFER_SIZE);
		sBuffer = string(szBuffer);
		if (sBuffer.find("<Files>") != -1)
		{
			while (sBuffer.find("</Files>") == -1)
			{
				fVcProj.getline(szBuffer, kBUFFER_SIZE);
				sBuffer = string(szBuffer);

				if (sBuffer.find("<File") != -1 && sBuffer.find("<FileConfiguration") == -1)
				{
					while (sBuffer.find("RelativePath=\"") == -1)
					{
						fVcProj.getline(szBuffer, kBUFFER_SIZE);
						sBuffer = string(szBuffer);
					}
					size_t pos = sBuffer.find("RelativePath=\"");
					size_t start = pos + strlen("RelativePath=\"");
					size_t end = sBuffer.find("\"", start+1);
					string sFilename = sBuffer.substr(start, end - start);
					if ( sFilename.substr(0,2) == string(".\\") || sFilename.substr(0,2) == string("./") )
						sFilename = sFilename.substr(2);
					//cout << sFilename << endl;

					string sFilenameMinusExt = sFilename.substr(0, sFilename.find_last_of("."));
					string sFilenameExt = sFilename.substr(sFilename.find_last_of(".") + 1);

					if (stricmp(sFilenameExt.c_str(),"c") == 0)
					{
						m_CSources += " " + sFilename;
						// the output file doesn't want any folders on it, the folder should instead be added to the VPATH
						size_t pos1=string::npos;
						size_t pos2=string::npos;
						pos1 = sFilenameMinusExt.find_last_of("\\");
						pos2 = sFilenameMinusExt.find_last_of("/");
						if (pos1 != string::npos || pos2 != string::npos)
						{
							string vpathToAdd;
							vpathToAdd += " " + sFilenameMinusExt.substr(0, std::max<size_t>(pos1 != string::npos ? pos1 : pos2, pos2 != string::npos ? pos2 : pos1)) + " ";
							if (m_CVPath.find(vpathToAdd) == string::npos)
								m_CVPath += vpathToAdd;
						}

						while (sFilenameMinusExt.find("\\") != string::npos)
						{
							sFilenameMinusExt = sFilenameMinusExt.substr( sFilenameMinusExt.find("\\") + 1);
						}
						while (sFilenameMinusExt.find("/") != string::npos)
						{
							sFilenameMinusExt = sFilenameMinusExt.substr( sFilenameMinusExt.find("/") + 1);
						}
						m_Objects += " " + sFilenameMinusExt + ".o";
					}
					else if (stricmp(sFilenameExt.c_str(),"cpp") == 0)
					{
						m_CXXSources += " " + sFilename;
						// the output file doesn't want any folders on it, the folder should instead be added to the VPATH
						size_t pos1=string::npos;
						size_t pos2=string::npos;
						pos1 = sFilenameMinusExt.find_last_of("\\");
						pos2 = sFilenameMinusExt.find_last_of("/");
						if (pos1 != string::npos || pos2 != string::npos)
						{
							string vpathToAdd;
							vpathToAdd += " " + sFilenameMinusExt.substr(0, std::max<size_t>(pos1 != string::npos ? pos1 : pos2, pos2 != string::npos ? pos2 : pos1)) + " ";
							if (m_CPPVPath.find(vpathToAdd) == string::npos)
								m_CPPVPath += vpathToAdd;
						}

						while (sFilenameMinusExt.find("\\") != string::npos)
						{
							sFilenameMinusExt = sFilenameMinusExt.substr( sFilenameMinusExt.find("\\") + 1);
						}
						while (sFilenameMinusExt.find("/") != string::npos)
						{
							sFilenameMinusExt = sFilenameMinusExt.substr( sFilenameMinusExt.find("/") + 1);
						}
						m_Objects += " " + sFilenameMinusExt + ".o";
					}
					else if (stricmp(sFilenameExt.c_str(),"vcl") == 0)
					{
						m_VclSources += " " + sFilename;
						// the output file doesn't want any folders on it, the folder should instead be added to the VPATH
						size_t pos1=string::npos;
						size_t pos2=string::npos;
						pos1 = sFilenameMinusExt.find_last_of("\\");
						pos2 = sFilenameMinusExt.find_last_of("/");
						if (pos1 != string::npos || pos2 != string::npos)
						{
							string vpathToAdd;
							vpathToAdd += " " + sFilenameMinusExt.substr(0, std::max<size_t>(pos1 != string::npos ? pos1 : pos2, pos2 != string::npos ? pos2 : pos1)) + " ";
							if (m_VclVPath.find(vpathToAdd) == string::npos)
								m_VclVPath += vpathToAdd;
						}

						while (sFilenameMinusExt.find("\\") != string::npos)
						{
							sFilenameMinusExt = sFilenameMinusExt.substr( sFilenameMinusExt.find("\\") + 1);
						}
						while (sFilenameMinusExt.find("/") != string::npos)
						{
							sFilenameMinusExt = sFilenameMinusExt.substr( sFilenameMinusExt.find("/") + 1);
						}
						m_Objects += " " + sFilenameMinusExt + ".o";
					}
				}
			}
		}
		else if (sBuffer.find("<Configurations>") != -1)
		{
			while (sBuffer.find("</Configurations>") == -1)
			{
				fVcProj.getline(szBuffer, kBUFFER_SIZE);
				sBuffer = string(szBuffer);

				if (sBuffer.find("<Configuration") != -1)
				{
					while (sBuffer.find("</Configuration>") == -1)
					{
						fVcProj.getline(szBuffer, kBUFFER_SIZE);
						sBuffer = string(szBuffer);

						if (sBuffer.find("<Tool") != -1)
						{
							while (sBuffer.find("/>") == -1)
							{
								fVcProj.getline(szBuffer, kBUFFER_SIZE);
								sBuffer = string(szBuffer);

								if (sBuffer.find("OUTPUT=") != -1)
								{ 
									size_t pos = sBuffer.find("OUTPUT=");
									size_t start = pos + strlen("OUTPUT=");
									size_t end = sBuffer.find(" ", start+1);
									m_OutputName = sBuffer.substr(start, end-start);
								}
								if (sBuffer.find("LIBRARY=1") != -1)
								{ 
									m_IsLibrary = true;
								}
								if (sBuffer.find("DEBUG=1") != -1)
								{ 
									m_IsDebug = true;
								}
								else if (sBuffer.find("RELEASE=1") != -1)
								{ 
									m_IsRelease = true;
								}
							}
						}

						if (sBuffer.find("Name=\"") != -1)
						{
							size_t pos = sBuffer.find("Name=\"");
							size_t start = pos + strlen("Name\"");
							size_t	 end = sBuffer.find("\"", start+1);

						}
					}
				}
			}
		}
	}
}