#ifndef PROJECT_HPP
#define PROJECT_HPP

#include <string>
#include <vector>
using std::string;
using std::vector;

class Project
{
public:

	class Dependency
	{
	public:

		string	m_Id1;
		string	m_Id2;

	private:
	};

										Project();

	string								m_Id1;
	string								m_Id2;
	string								m_Name;
	string								m_Location;

	int									m_TreeLevel;	// 0 for parent, > 0 means this is a dependency
	bool								m_IsNeeded;		// is this project a dependency of what is being built ?

	vector<Dependency>					m_Dependencies;

	bool operator < (const Project &rhs) const { return (m_TreeLevel > rhs.m_TreeLevel); }

	string								m_CSources;
	string								m_CXXSources;
	string								m_VclSources;
	string								m_Objects;
	
	string								m_CVPath;
	string								m_CPPVPath;
	string								m_VclVPath;

	string								m_OutputName;

	bool								m_IsLibrary;

	void								CalculateSourceAndObjectFiles();

	bool								m_IsDebug;
	bool								m_IsRelease;

private:

};

inline Project::Project()
{
	m_IsLibrary = false;
	m_IsDebug = m_IsRelease = false;
}

#endif
