#include "stdafx.h"
#include "VcProjParser.hpp"

using namespace std;

const static int	kBUFFER_SIZE			= 1024;

const static int	kMAX_ID_LENGTH			= 512;
const static int	kMAX_NAME_LENGTH		= 512;
const static int	kMAX_LOCATION_LENGTH	= 512;

int process(const char *filename, ofstream *outstream)
{
	ifstream fVcProj(filename);
	char	szBuffer[kBUFFER_SIZE];
	string	sBuffer;

	string sCSrcs;
	string sCppSrcs;
	string sVclSrcs;
	string sObjects;

	if (!fVcProj.is_open())
	{
		printf("Could not open specified project file (.vcproj)\n");
		return -1;
	}

	while ( !fVcProj.eof() )
	{
		fVcProj.getline(szBuffer, kBUFFER_SIZE);
		sBuffer = string(szBuffer);
		if (sBuffer.find("<Files>") != -1)
		{
			while (sBuffer.find("</Files>") == -1)
			{
				fVcProj.getline(szBuffer, kBUFFER_SIZE);
				sBuffer = string(szBuffer);

				if (sBuffer.find("<File") != -1 && sBuffer.find("<FileConfiguration") == -1)
				{
					while (sBuffer.find("RelativePath=\"") == -1)
					{
						fVcProj.getline(szBuffer, kBUFFER_SIZE);
						sBuffer = string(szBuffer);
					}
					size_t pos = sBuffer.find("RelativePath=\"");
					size_t start = pos + strlen("RelativePath=\"");
					size_t end = sBuffer.find("\"", start+1);
					string sFilename = sBuffer.substr(start, end - start);
					if ( sFilename.substr(0,2) == string(".\\") || sFilename.substr(0,2) == string("./") )
						sFilename = sFilename.substr(2);
					//cout << sFilename << endl;

					string sFilenameMinusExt = sFilename.substr(0, sFilename.find_last_of("."));
					string sFilenameExt = sFilename.substr(sFilename.find_last_of(".") + 1);

					if (stricmp(sFilenameExt.c_str(),"c") == 0)
					{
						sCSrcs += " " + sFilename;
						// the output file doesn't any folders on it
						while (sFilenameMinusExt.find("\\") != string::npos)
						{
							sFilenameMinusExt = sFilenameMinusExt.substr( sFilenameMinusExt.find("\\") + 1);
						}
						while (sFilenameMinusExt.find("/") != string::npos)
						{
							sFilenameMinusExt = sFilenameMinusExt.substr( sFilenameMinusExt.find("/") + 1);
						}
						sObjects += " " + sFilenameMinusExt + ".o";
					}
					else if (stricmp(sFilenameExt.c_str(),"cpp") == 0)
					{
						sCppSrcs += " " + sFilename;
						sObjects += " " + sFilenameMinusExt + ".o";
					}
					else if (stricmp(sFilenameExt.c_str(),"vcl") == 0)
					{
						sVclSrcs += " " + sFilename;
						sObjects += " " + sFilenameMinusExt + ".o";
					}
				}
			}
		}
		else if (sBuffer.find("<Configurations>") != -1)
		{
			while (sBuffer.find("</Configurations>") == -1)
			{
				fVcProj.getline(szBuffer, kBUFFER_SIZE);
				sBuffer = string(szBuffer);

				if (sBuffer.find("<Configuration") != -1)
				{
					while (sBuffer.find("</Configuration>") == -1)
					{
						fVcProj.getline(szBuffer, kBUFFER_SIZE);
						sBuffer = string(szBuffer);

						if (sBuffer.find("<Tool") != -1)
						{
							while (sBuffer.find("/>") == -1)
							{
								fVcProj.getline(szBuffer, kBUFFER_SIZE);
								sBuffer = string(szBuffer);
								
								if (sBuffer.find("OUTPUT=") != -1)
								{ 
									size_t pos = sBuffer.find("Output=\"");
									size_t start = pos + strlen("Output=\"");
									size_t end = sBuffer.find("\"", start+1);

								}
								if (sBuffer.find("LIBRARY=1") != -1)
								{ 
									printf("Here\n");
								}
							}
						}

						if (sBuffer.find("Name=\"") != -1)
						{
							size_t pos = sBuffer.find("Name=\"");
							size_t start = pos + strlen("Name\"");
							size_t	 end = sBuffer.find("\"", start+1);

						}
					}
				}
			}
		}
	}

	if (outstream == NULL)
	{
		cout << "C_SRCS = " << sCSrcs << endl;
		cout << "CXX_SRCS = " << sCppSrcs << endl;
		cout << "VCL_SRCS = " << sVclSrcs << endl;
		cout << "OBJECTS = " << sObjects << endl;
	}
	else
	{
		*outstream << "C_SRCS = " << sCSrcs << endl;
		*outstream << "CXX_SRCS = " << sCppSrcs << endl;
		*outstream << "VCL_SRCS = " << sVclSrcs << endl;
		*outstream << "OBJECTS = " << sObjects << endl;
	}

	return 0;
}